package cz.muni.fi.icehockeymanager.arenareservation.facade;

import cz.muni.fi.icehockeymanager.arenareservation.api.create.CreateContactPersonDto;
import cz.muni.fi.icehockeymanager.arenareservation.api.view.ContactPersonDetailDto;
import cz.muni.fi.icehockeymanager.arenareservation.mappers.ContactPersonMapper;
import cz.muni.fi.icehockeymanager.arenareservation.service.ContactPersonService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class ContactPersonFacade {
    private final ContactPersonService contactPersonService;
    private final ContactPersonMapper contactPersonMapper;

    @Autowired
    public ContactPersonFacade(ContactPersonService contactPersonService, ContactPersonMapper contactPersonMapper) {
        this.contactPersonService = contactPersonService;
        this.contactPersonMapper = contactPersonMapper;
    }

    public ContactPersonDetailDto createContactPerson(CreateContactPersonDto createContactPersonDto) {
        return contactPersonMapper.mapContactPersonEntityToContactPersonDetailDto(
                contactPersonService.save(
                        contactPersonMapper.mapCreatePersonDtoToContactPersonEntity(createContactPersonDto)
                ));
    }

    public void deleteContactPerson(Long contactPersonId) {
        contactPersonService.deleteById(contactPersonId);
    }
}
