package cz.muni.fi.icehockeymanager.arenareservation.mappers;

import cz.muni.fi.icehockeymanager.arenareservation.api.create.CreateArenaDto;
import cz.muni.fi.icehockeymanager.arenareservation.api.view.ArenaDetailDto;
import cz.muni.fi.icehockeymanager.arenareservation.api.view.ArenaDto;
import cz.muni.fi.icehockeymanager.arenareservation.data.domain.Arena;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import java.util.List;

@Mapper(componentModel = "spring", uses = AddressMapper.class)
public interface ArenaMapper {
    List<ArenaDto> mapArenaListToArenaDtoList(List<Arena> arenas);

    @Mapping(source = "address.city", target = "city")
    @Mapping(source = "address.countryISO", target = "countryISO")
    ArenaDto mapArenaEntityToArenaDto(Arena arena);

    @Mapping(source = "street", target = "address.street")
    @Mapping(source = "streetNumber", target = "address.streetNumber")
    @Mapping(source = "city", target = "address.city")
    @Mapping(source = "region", target = "address.region")
    @Mapping(source = "countryISO", target = "address.countryISO")
    Arena mapCreateArenaDtoToArenaEntity(CreateArenaDto createArenaDto);

    @Mapping(source = "addressDto", target = "address")
    Arena mapArenaDetailDtoToArenaEntity(ArenaDetailDto arenaDetailDto);

    @Mapping(source = "address", target = "addressDto")
    ArenaDetailDto mapArenaEntityToArenaDetailDto(Arena arena);
}
