package cz.muni.fi.icehockeymanager.arenareservation.mappers;

import cz.muni.fi.icehockeymanager.arenareservation.api.create.CreateArenaReservationRecordDto;
import cz.muni.fi.icehockeymanager.arenareservation.api.view.ArenaReservationRecordDetailDto;
import cz.muni.fi.icehockeymanager.arenareservation.api.view.ArenaReservationRecordDto;
import cz.muni.fi.icehockeymanager.arenareservation.data.domain.ReservationRecord;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import java.util.List;

@Mapper(componentModel = "spring", uses = {ArenaMapper.class, ContactPersonMapper.class})
public interface ReservationRecordMapper {

    ReservationRecord mapCreateReservationDtoToReservationRecord(CreateArenaReservationRecordDto recordDto);

    @Mapping(source = "arena", target = "arenaDetailDto")
    @Mapping(source = "contactPerson", target = "contactPersonDetailDto")
    ArenaReservationRecordDetailDto mapReservationRecordToRecordDto(ReservationRecord reservationRecord);

    List<ArenaReservationRecordDetailDto> mapReservationRecordListToRecordDtoList(List<ReservationRecord> reservationRecordList);

    @Mapping(source = "arena", target = "arenaDto")
    ArenaReservationRecordDto mapReservationRecordToBasicReservationRecordDto(ReservationRecord reservationRecord);

    List<ArenaReservationRecordDto> mapReservationRecordListToBasicReservationRecordDtoList(List<ReservationRecord> reservationRecordList);
}
