package cz.muni.fi.icehockeymanager.discussionforum.service;

import cz.muni.fi.icehockeymanager.discussionforum.api.dto.view.UserDto;
import cz.muni.fi.icehockeymanager.discussionforum.config.DiscussionCoreProperties;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.oauth2.jwt.Jwt;
import org.springframework.stereotype.Service;
import org.springframework.web.reactive.function.client.WebClient;

@Service
public class UserInfoService {

    private final WebClient client;

    @Autowired
    public UserInfoService(DiscussionCoreProperties discussionCoreProperties) {
        this.client = WebClient.create(discussionCoreProperties.getUrl() + "/users/email");
    }

    public UserDto getUserInfo(Jwt principal) {
        return client.get().uri("/" + principal.getClaimAsString("email")).retrieve().bodyToMono(UserDto.class).block();
    }
}
