package cz.muni.fi.icehockeymanager.core.data.domain;

import cz.muni.fi.icehockeymanager.core.data.enums.PlayerPosition;
import jakarta.persistence.*;
import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Min;
import lombok.*;

import java.io.Serializable;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@ToString
@EqualsAndHashCode
@Entity
@Table(name = "player")
public class Player implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;
    @Column(name = "first_name", length = 50)
    private String firstName;
    @Column(name = "last_name", length = 50)
    private String lastName;
    @Column(name = "strength")
    @Min(1)
    @Max(100)
    private Integer strength;
    @Column(name = "position", length = 10)
    @Enumerated(EnumType.STRING)
    private PlayerPosition position;
    @ManyToOne
    @JoinColumn(name = "team_id")
    private Team team;

    public Player(String firstName, String lastName, Integer strength, PlayerPosition position) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.strength = strength;
        this.position = position;
    }
}
