package cz.muni.fi.icehockeymanager.core.data.domain;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import lombok.*;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@ToString
@EqualsAndHashCode
@Entity
@Table(name = "schedule")
public class Schedule implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;
    @NotNull
    @Column(name = "schedule_year")
    private int year;
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "league_id")
    private League league;
    @OneToMany(mappedBy = "schedule")
    private List<Game> games = new ArrayList<>();

    public Schedule(int year, League league) {
        this.year = year;
        this.league = league;
    }

    public void addGame(Game game) {
        games.add(game);
        game.setSchedule(this);
    }
}
