package cz.muni.fi.icehockeymanager.core.data.domain;

import jakarta.persistence.*;
import lombok.*;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@ToString
@EqualsAndHashCode
@Entity
@Table(name = "hockey_user")
public class User implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;
    @Column(name = "first_name", length = 50)
    private String firstName;
    @Column(name = "last_name", length = 50)
    private String lastName;
    @Column(name = "email", unique = true, nullable = false, length = 120)
    private String email;
    @Column(name = "is_admin", nullable = false)
    private Boolean isAdmin;
    @OneToMany(mappedBy = "createdBy")
    private List<Team> teams;

    public User(String firstName, String lastName, String email, Boolean isAdmin) {
        this(firstName, lastName, email);
        this.isAdmin = isAdmin;
    }

    public User(String firstName, String lastName, String email) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.email = email;
        this.isAdmin = false;  // TODO
        this.teams = new ArrayList<>();
    }
}
