package cz.muni.fi.icehockeymanager.core.mappers;

import cz.muni.fi.icehockeymanager.core.api.view.GameDetailDto;
import cz.muni.fi.icehockeymanager.core.api.view.GameDto;
import cz.muni.fi.icehockeymanager.core.data.domain.Game;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import java.util.List;

@Mapper(componentModel = "spring")
public interface GameMapper {

    @Mapping(target = "scheduleId", source = "game.schedule.id")
    @Mapping(target = "homeTeamId", source = "game.homeTeam.id")
    @Mapping(target = "awayTeamId", source = "game.awayTeam.id")
    GameDto mapToDto(Game game);
    GameDetailDto mapToDetailDto(Game game);
    Game mapToEntity(GameDto gameDto);

    List<GameDto> mapToListDto(List<Game> games);
}
