package cz.muni.fi.icehockeymanager.report.data.domain;

import jakarta.persistence.*;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Entity
@Table(name = "subscriber")
public class Subscriber implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    @Column(length = 50)
    private String name;
    @Column(length = 120)
    private String mail;

    @Column(name = "player_ref_id")
    private Long playerRefId;

    @OneToMany(mappedBy = "subscriber", cascade = CascadeType.ALL, orphanRemoval = true)
    private List<Subscription> subscriptions = new ArrayList<>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getMail() {
        return mail;
    }

    public void setMail(String mail) {
        this.mail = mail;
    }

    public Long getPlayerRefId() {
        return playerRefId;
    }

    public void setPlayerRefId(Long createdById) {
        this.playerRefId = createdById;
    }

    public List<Subscription> getSubscriptions() {
        return subscriptions;
    }

    public void setSubscriptions(List<Subscription> subscriptions) {
        this.subscriptions.clear();
        this.subscriptions.addAll(subscriptions);
    }

    public void addSubscription(Subscription subscription) {
        this.subscriptions.add(subscription);
        subscription.setSubscriber(this);
    }

    public void removeSubscription(Subscription subscription) {
        this.subscriptions.remove(subscription);
        subscription.setSubscriber(null);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }

        if (!(o instanceof Subscriber other)) {
            return false;
        }

        return Objects.equals(getName(), other.getName()) &&
                Objects.equals(getMail(), other.getMail()) &&
                Objects.equals(getSubscriptions(), other.getSubscriptions());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getName(), getMail(), getSubscriptions());
    }
}
