package cz.muni.fi.icehockeymanager.report.data.domain;

import cz.muni.fi.icehockeymanager.report.api.view.SubscriberDto;
import cz.muni.fi.icehockeymanager.report.data.enums.SubscribeSubject;
import jakarta.persistence.*;

import java.time.LocalDate;
import java.util.Objects;

@Entity
@Table(name = "subscription")
public class Subscription {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "subscriber_id", referencedColumnName = "id")
    private Subscriber subscriber;

    @Enumerated(EnumType.STRING)
    @Column(name = "subscribe_subject", length = 18)
    private SubscribeSubject subscribeSubject;

    @Temporal(TemporalType.DATE)
    @Column(name = "date_added")
    private LocalDate dateAdded;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Subscriber getSubscriber() {
        return subscriber;
    }

    public void setSubscriber(Subscriber subscriber) {
        this.subscriber = subscriber;
    }

    public SubscribeSubject getSubscribeSubject() {
        return subscribeSubject;
    }

    public void setSubscribeSubject(SubscribeSubject subscribeSubject) {
        this.subscribeSubject = subscribeSubject;
    }

    public LocalDate getDateAdded() {
        return dateAdded;
    }

    public void setDateAdded(LocalDate dateAdded) {
        this.dateAdded = dateAdded;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }

        if (!(o instanceof Subscription other)) {
            return false;
        }

        return Objects.equals(getSubscriber(), other.getSubscriber()) &&
                Objects.equals(getSubscribeSubject(), other.getSubscribeSubject()) &&
                Objects.equals(getDateAdded(), other.getDateAdded());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getSubscriber(), getSubscribeSubject(), getDateAdded());
    }
}