﻿#RUN SQL scripts
New-Alias -Name docker_command -Value podman

$dbs = (New-Object psobject -Property @{DockerDbName = "hockey-core-db"; PSuser = "postgres"; DBName = "hockey-core"}),
(New-Object psobject -Property @{DockerDbName = "discussion-forum-db"; PSuser = "postgres"; DBName = "discussion-forum"}),
(New-Object psobject -Property @{DockerDbName = "arena-reservation-db"; PSuser = "postgres"; DBName = "arena-reservation"}),
(New-Object psobject -Property @{DockerDbName = "report-db"; PSuser = "postgres"; DBName = "report"})

foreach ($db in $dbs) 
{
    $docker_id = ((docker_command ps | Select-String $db.DockerDbName | Out-String).Trim() -split " ")[0]

    docker_command exec $docker_id psql -U $db.PSuser -d $db.DBName -a -f ./tmp/clear.sql
    docker_command exec $docker_id psql -U $db.PSuser -d $db.DBName -a -f ./tmp/seed.sql
}

Remove-Item Alias:docker_command