#!/bin/bash
shopt -s expand_aliases
alias docker_command='docker'

dbs=("hockey-core-db;postgres;hockey-core" "discussion-forum-db;postgres;discussion-forum" "arena-reservation-db;postgres;arena-reservation" "report-db;postgres;report")

for db in ${dbs[@]}; do 
	IFS=';'
	read -a strarr <<< "$db"
	docker_id=$(docker_command ps | grep ${strarr[0]} | cut -f 1 -d " ")
	docker_command exec $docker_id psql -U ${strarr[1]} -d ${strarr[2]} -a -f ./tmp/clear.sql
	docker_command exec $docker_id psql -U ${strarr[1]} -d ${strarr[2]} -a -f ./tmp/seed.sql
done